precision mediump float;

uniform sampler2D u_textureBase;
uniform sampler2D u_textureGroups;
uniform sampler2D u_textureColors;
uniform int u_mode;

varying vec2 v_texCoord;

const int MODE_GROUPS = 0;
const int MODE_GROUP_LINE = 1;


void groupPainting() {
    vec2 coords = texture2D( u_textureGroups, v_texCoord ).st;
    vec4 lineColor = texture2D( u_textureColors, vec2(0.0, 0.0) );
    vec4 finalColor = texture2D( u_textureColors, coords );

    if ( all( equal( finalColor, lineColor ) ) ) {
        finalColor = vec4( 0.0, 0.0, 0.0, 1.0 );
    }

    gl_FragColor = finalColor;
}


void regularTexture() {
    gl_FragColor = texture2D( u_textureBase, v_texCoord );
}


void main() {
    if ( u_mode == MODE_GROUPS ) {
        groupPainting();
    }
    else {
        regularTexture();
    }
}